<?php

namespace HCUE\AtencionMedicBundle\Entity\Repository;

/**
 * Descripcion de class CieclasificacionRepository extends EntityRepository
 * @author Lenin Vallejos
 */
use Doctrine\ORM\EntityRepository;
use HCUE\AtencionMedicBundle\Entity\Constantes;

/**
 * CieRepository
 *
 * This class was generated by the Doctrine ORM. Add your own custom
 * repository methods below.
 */
class CieclasificacionRepository extends EntityRepository
{

    /**
     * Obtiene el QueryBuilder de la lista de todos los capitulos activos del CIE establecidos en la tabla Cieclasificacion
     * @return QueryBuilder
     */
    public function getCieclasificacionAllparentsQueryBuilder()
    {
        $qb = $this->createQueryBuilder('ciecla')
            ->select("ciecla")
            ->Where('ciecla.cieclasificacion_id is null')
            ->andWhere('ciecla.estado=:estado')
            ->setParameter("estado", Constantes::ESTADOGENERALHABILITADO);

        return $qb;
    }


    /**
     * Obtiene el QueryBuilder de la lista de todos los grupos activos del CIE establecidos en la tabla Cieclasificacion
     * @return QueryBuilder
     */
    public function getCieclasificacionAllchildrensQueryBuilder()
    {
        $qb = $this->createQueryBuilder('ciecla')
            ->select("ciecla")
            ->Where('ciecla.cieclasificacion_id is not null')
            ->andWhere('ciecla.estado=:estado')
            ->setParameter("estado", Constantes::ESTADOGENERALHABILITADO);
        return $qb;
    }

    /**
     * Obtiene la lista de lista de todos los capitulos activos del CIE establecidos en la tabla Cieclasificacion
     * @param boolean $arrayResult <true> para retornar cada modelo o entidad de la lista como un array
     * @return Array Lista de Objetos de tipo "HCUE\AtencionMedicBundle\Entity\Cieclasificacion"
     */
    public function getCieclasificacionAllparents($arrayResult = false)
    {
        $queryBuilder = $this->getCieclasificacionAllparentsQueryBuilder();
        $q = $queryBuilder->getQuery();

        $resultId = ($arrayResult) ? "result_array_cieclasificacion_allparents" : "result_cieclasificacion_allparents";
        $q->useQueryCache(true)
            ->useResultCache(true, null, $resultId);

        return ($arrayResult) ? $q->getArrayResult() : $q->getResult();
    }

    /**
     * Obtiene la lista de lista de todos de todos los grupos activos del CIE establecidos en la tabla Cieclasificacion
     * @param boolean $arrayResult <true> para retornar cada modelo o entidad de la lista como un array
     * @return Array Lista de Objetos de tipo "HCUE\AtencionMedicBundle\Entity\Cieclasificacion"
     */
    public function getCieclasificacionAllchildrens($arrayResult = false)
    {
        $queryBuilder = $this->getCieclasificacionAllchildrensQueryBuilder();
        $q = $queryBuilder->getQuery();

        $resultId = ($arrayResult) ? "result_array_cieclasificacion_allchildrens" : "result_cieclasificacion_allchildrens";
        $q->useQueryCache(true)
            ->useResultCache(true, null, $resultId);

        return ($arrayResult) ? $q->getArrayResult() : $q->getResult();
    }
}
